/* BioTree.cpp */
/*
()
() **************************************************************************
() * -inline   BioTree                                        *
() **************************************************************************
()
*/

#include "BioTree.h"

/*
()       : scaleLengths(x)  (()  ң  x );
()    : ()   ң ()  x ;
()   :  -(;
()  : .
()
*/
void BioTree::scaleLengths( double scaleFactor )
  {
    distFromParent *= scaleFactor;
    for ( uint n=0; n<numberOfChildren(); n++ )
      child(n).scaleLengths(scaleFactor);
  }

/*
()       : printOn( ostream outputStream )  (  ...);
()    :         ;
()   :   ;
()  : ---.
()
*/
void BioTree::printOn( ostream& os ) const
  {
    Tree::printOn(os);
    if ( hasParent() && distanceFromParent() != 1 )
      os << ':' << distanceFromParent();
  }


RBioTree BioTree::operator=( RCBioTree aBioTree )
  {
    Tree::operator=(aBioTree);

    distFromParent = aBioTree.distanceFromParent();

    return ME;
  }

RTree BioTree::operator=( RCTree aTree )
  {
    Tree::operator=(aTree);

    if ( aTree.isA() != treeClass )                      // !!! BAD !!!
      distFromParent = RCBioTree(aTree).distFromParent;  // !!! BAD !!!

    return ME;
  }

