/* ClArray.cpp */
/*
()
() **************************************************************************
() * -inline   ClArray                                        *
() **************************************************************************
()
*/

#include "ClArray.h"

/*
()       : insertBefore();
()    :       ;
()   :   , ;
()  : OK / ERROR (/).
()
*/
int ClArray::insertBefore( RCClonable o, reg int i )
  {
    if ( i<0 )  //    
      return ERROR;
    if ( i<size() )  //    
      {
        CHECK( setSize(size()+1), "8*O" )     //   1  
        for ( reg int j=size()-2; j>=i; j-- ) //  ""  1 
          elPtr(j+1)=elPtr(j);
        elPtr(i)=NULL;
      }
    if ( i<=fBI )
      fBI++;  //     
    return addAt(o,i);  //   i-   
  }

/*
()       : insertBefore_lockSize();
()    :       ,
                   ;
()   :   , ;
()  : OK / ERROR (/).
()
*/
int ClArray::insertBefore_LockSize( RCClonable o, reg int i )
  {
    if ( indexOutOfRange(i) )  //    
      return ERROR;
    if ( elPtr(size()-1) != NULL )
      delete elPtr(size()-1);
    for ( reg int j=size()-2; j>=i; j-- )  //  ""  1  
      elPtr(j+1)=elPtr(j);
    elPtr(i)=NULL;
    if ( i<=fBI && fBI<size() )
      fBI++;  //     
    return addAt(o,i);  //   i-   
  }

/*
()       : removeAtWithShift();
()    :        "" ;
()   : ;
()  : OK / ERROR (/).
()
*/
int ClArray::removeAtWithShift( reg int i )
  {
    int _fBI=fBI;  //     
    if ( removeAt(i) == ERROR )
      return ERROR;
    fBI = _fBI;    //     
    while ( ++i<size() )
      elPtr(i-1)=elPtr(i);
    elPtr(size()-1)=0;
    if ( i<fBI )
      fBI--;  //     
    else if ( i==fBI )
      while ( ++fBI<size() && elPtr(fBI)!=NULL );
    setSize(size()-1);
    return OK;
  }

/*
()       : minimizeSize();
()    :    ( );
()   : ---;
()  : ---.
()
*/
void ClArray::minimizeSize()
  {
    // :  elPtr(k)  k<i ,  elPtr(l)  l>j 
    // : i>=j (i , j  )
    reg int i,j;
    for ( i=firstBlankIndex(),j=size()-1; i<j; j-- )
      if ( elPtr(j) != NULL )
        for ( elPtr(i++) = elPtr(j), elPtr(j) = NULL;
              i<j && elPtr(i) != NULL; i++ );
    if ( i < size() )
      {
        fBI=i;
        setSize(i);
      }
  }

