/* ClArray.h */

#ifndef __ClArray_h
#define __ClArray_h

#include "ClArBase.h"

_CLASSDEF(ClArray)

/*     Clonable */
class ClArray : public ClArrayBase
  {

  public :

    /* / */
    ClArray()              : ClArrayBase()        {}
    ClArray( uns d )       : ClArrayBase(d)       {}
    ClArray( RCClArray A ) : ClArrayBase(A.delta) { ME = A; }
    virtual ~ClArray() {}

    /*   */

    virtual int add      ( RCClonable o )
      { return ClArrayBase::add(o); }
    virtual int replace  ( RCClonable o1, RCClonable o2 )
      { return ClArrayBase::replace(o1,o2); }
    virtual int addAt    ( RCClonable o,  reg int i )
      { return ClArrayBase::addAt(o,i); }
    virtual int removeAt (                reg int i )
      { return ClArrayBase::removeAt(i); }

    int  insertBefore ( RCClonable o, reg int i );//   .-
    int  insertAfter  ( RCClonable o, reg int i ) //   .-
      { return insertBefore( o, i+1 ); }
    int  insertBefore_LockSize ( RCClonable o, reg int i );// . -
    int  insertAfter_LockSize  ( RCClonable o, reg int i ) // . -
      { return insertBefore_LockSize( o, i+1 ); }

    int  removeAtWithShift ( reg int i );  //    ""

    void minimizeSize(); //  

    /*   */
    RClArray operator = ( RCClArray A )
      { ClArrayBase::operator=(A); return ME; }

    /*    Object'a */
    virtual classType   isA    () const { return clArrayClass; }
    virtual const char* nameOf () const { return "ClArray"; }

    /*  "" Clonable */
    virtual PClonable clone() const { return new ClArray(ME); }

  };

#endif  // __ClArray_h

