/* ClString.cpp */

#include "ClString.h"

#include <ctype.h>
#include <stdio.h>

/*     **************************************/
inline void String::_copyFrom( register const char* source )
  { memcpy( theString, source, len ); theString[len] = '\0'; }
inline void String::_allocateString()
  { if ( theString ) delete theString;  theString = new char[len+1]; }
inline void String::_changeLength( unsigned newLength )
  { if ( len != newLength ) len = newLength, _allocateString(); }

/* ""     */
void String::constructor( long n )
  {
    char buf[256];
//    itoa( n, buf, 10 );  // [  -  long (!!!)]
    sprintf( buf, "%ld", n );
    len = strlen(buf);   //    
    _allocateString();   //   
    _copyFrom(buf);      //   
  }

/* ""     */
void String::constructor( unsigned long n )
  {
    char buf[256];
//    itoa( n, buf, 10 );  // [  -  long (!!!)]
    sprintf( buf, "%ld", n );
    len = strlen(buf);   //    
    _allocateString();   //   
    _copyFrom(buf);      //   
  }

/*       **************************/


/*     */
String::String( char c ) : len(1), theString(NULL)
  { _allocateString(); _copyFrom(&c); }

/*     */
String::String( const char* aPtr ) : len(0), theString(NULL)
  {
    if ( aPtr==NULL ) aPtr="";  //   ,    
    len = strlen(aPtr);         //    
    _allocateString();          //   
    _copyFrom(aPtr);            //   
  }

/*   */
String::String( RCString src ) : Sortable(), len(src.len), theString(NULL)
  { _allocateString(); _copyFrom( src ); }

/*     */
String::String( bool x ) : len(0), theString(NULL)
  {
    const char* const value = ( x ? "true" : "false" );
    len = strlen(value);  //    
    _allocateString();    //   
    _copyFrom(value);     //   
  }

/*     */
String::String( double x, int ndig ) : len(0), theString(NULL)
  {

//    //    `gcvt' (    ANSI)
//    char buf[256];
//    gcvt( x, ndig, buf );

    char fmt[16]; //    sprintf
    sprintf( fmt, "%%.%dg", ndig ); // 

    char * buf = new char[ndig+16]; //   ,  sprintf
    sprintf( buf, fmt, x ); // 

    len = strlen(buf);  //    
    _allocateString();  //   
    _copyFrom(buf);     //   

    delete buf;

//    //  -   ""  'gcvt'.
//    if ( double(ME) == 0 )
//      ME = "0";
//    if ( theString[0] == '.' )
//      ME = String('0') + ME;
//    if ( theString[0] == '-' && theString[1] == '.' )
//      {
//        theString[0] = '0';
//        ME = String('-') + ME;
//      }

  }

/*  (==)    */
bool String::isEqual( const char* aPtr ) const
  {
    if ( strlen(aPtr) != len )
      return false;
    for ( register unsigned int i=0; i<len; i++ )
      if ( theString[i] != aPtr[i] )
        return false;
    return true;
  }

/*  (==)    String */
bool String::isEqual( RCString anotherString ) const
  {
    if ( anotherString.len != len )
      return false;
    for ( register unsigned int i=0; i<len; i++ )
      if ( theString[i] != anotherString[i] )
        return false;
    return true;
  }

/*  (<)    */
bool String::isLessThan( const char* ptr ) const
  {
    for ( register unsigned int i=0; i<=len; i++ )
      if ( theString[i] != ptr[i] )
        return ( theString[i] < ptr[i] );
    return false;
  }

/*  (<)     String */
bool String::isLessThan( RCString anotherString ) const
  {
    for ( register unsigned int i=0; i<=len; i++ )
      if ( theString[i] != anotherString.theString[i] )
        return ( theString[i] < anotherString[i] );
    return false;
  }

/*      */
RString String::operator=( char c )
  { _changeLength(1); _copyFrom(&c); return ME; }

/*      */
RString String::operator=( const char* aPtr )
  { _changeLength( strlen(aPtr) ); _copyFrom(aPtr); return ME; }

/*   (    String) */
RString String::operator=( RCString sourceString )
  { _changeLength( sourceString.len ); _copyFrom( sourceString ); return ME; }

/*  +=    */
RString String::operator+=( char c )
  {
    char* oldString=theString;
    theString = new char[++len+1];
    memcpy( theString, oldString, len-1 );
    delete oldString;
    theString[len-1] = c;
    theString[len] = '\0';

    return ME;
  }

/*  +=    */
RString String::operator+=( const char* aPtr )
  {
    int strLen = strlen(aPtr);
    if ( strLen > 0 )
      {
        unsigned oldLen=len;
        char*    oldString=theString;
        len += strLen;
        theString = new char[len+1];
        for ( register unsigned int i=0; i<=len; i++ )
          theString[i] = ( i<oldLen ? oldString[i] : aPtr[i-oldLen] );
        delete oldString;
      }

    return ME;
  }

/*  +=    String */
RString String::operator+=( RCString anotherString )
  {
    if ( anotherString.len > 0 )
      {
        unsigned oldLen=len;
        char*    oldString=theString;
        len += anotherString.len;
        theString = new char[len+1];
        for ( register unsigned i=0; i<=len; i++ )
          theString[i] = ( i<oldLen ? oldString[i]
                                    : anotherString.theString[i-oldLen] );
        delete oldString;
      }

    return ME;
  }

String String::operator*( int n ) const
  {
    String result;

    if ( n < 4 )
      for ( int i=0; i<n; i++ )
        result += ME;
    else
      {
        delete result.theString;
        result.len = len*n;
        result.theString = new char[result.len+1];
        for ( reg int i=0; i<n; i++ )
          for ( reg uns j=0; j<len; j++ )
            result.theString[i*len+j] = theString[j];
        result.theString[result.len]='\0';
      }

    return result;
  }

bool String::isBlank() const
  {
    for ( register unsigned int i=0; i<len; i++ )
      if ( theString[i] != ' ' && theString[i] != '\t' && theString[i] != '\n' )
        return false;
    return true;
  }

bool String::startsWith ( RCString substr, int i0 ) const
  {
    if ( i0 < 0 || i0 > int(len-substr.len) ) return false;
    for ( register unsigned int i=0; i<substr.len && i0+i<len; i++ )
      if ( substr.theString[i] != theString[i0+i] )
        return false;
    return true;
  }

int String::indexOf( register const char charToFind, register int i0 ) const
  {
    if ( i0 < 0        ) i0 = 0;
    if ( i0 > int(len) ) i0 = len;
    register unsigned int i;
    for ( i=i0; i<len; i++ )
      if ( theString[i] == charToFind )
        break;
    return i;
  }

int String::lastIndexOf( register const char charToFind, register int i0 ) const
  {
    if ( i0 < 0 ) return -1;
    if ( i0 > int(len-1) ) i0 = len-1;
    register int i;
    for ( i=i0; i>=0; i-- )
      if ( theString[i] == charToFind )
        break;
    return i;
  }

int String::indexOf( RCString stringToFind, register int i0 ) const
  {
    register const unsigned int l=stringToFind.len;
    if ( i0 < 0          ) i0 = 0;
    if ( i0 > int(len-l) ) i0 = len-l;
    register int i;
    for ( i=i0; i<=int(len-l); i++ )
      {
        register unsigned int j;
        for ( j=0; j<l; j++ )
          if ( theString[i+j] != stringToFind.theString[j] )
            break;
        if ( j == l )
          break;
      }
    if ( i>int(len-l) ) i = len;
    return i;
  }

// !!!  - . =(  ,      . =)
int String::lastIndexOf( RCString stringToFind, register int i0 ) const
  {
    register const unsigned int l=stringToFind.len;
    if ( i0   < 0   ) i0 = 0;
    if ( i0+l > len )
      return -1;
    register int i;
    for ( i=len-l; i>=i0; i-- )
      {
        register unsigned int j;
        for ( j=0; j<l; j++ )
          if ( theString[i+j] != stringToFind.theString[j] )
            break;
        if ( j == l )
          break;
      }
    return i;
  }

String String::substring( register int i1, int i2 ) const
  {
    if ( i1 <  0        ) i1 = 0;
    if ( i2 >  int(len) ) i2 = len;
    if ( i1 >= i2       ) return String();
    register const unsigned int l=i2-i1;
    char*const strPtr=new char[l+1];
    for ( register unsigned int i=0; i<l; i++ )
      strPtr[i] = theString[i1+i];
    strPtr[l] = '\0';
    String result( strPtr );
    delete strPtr;
    return result;
  }

String String::trim() const
  {
    register int i1=-1, i2=len;
    while ( ++i1<=i2 )
      if ( theString[i1]!=' ' && theString[i1]!='\t' && theString[i1]!='\n' )
        break;
    while ( --i2>=i1 )
      if ( theString[i2]!=' ' && theString[i2]!='\t' && theString[i2]!='\n' )
        break;
    return substring( i1, i2+1 );
  }

String String::toLowerCase() const
  {
    char*const strPtr=new char[len+1];
    for ( register unsigned int i=0; i<len; i++ )
      strPtr[i] = char(tolower(theString[i]));
    strPtr[len] = '\0';
    String result( strPtr );
    delete strPtr;
    return result;
  }

String String::toUpperCase() const
  {
    String result;
    result.len=len;
    result._allocateString();
    result.theString[len] = '\0';
    for ( reg int i=len-1; i>=0; i-- )
      result.theString[i] = char(toupper(theString[i]));
    return result;
  }

int String::replace( register const char ch1, register const char ch2 )
  {
    register unsigned int counter=0;
    for ( register unsigned int i=0; i<len; i++ )
      if ( theString[i] == ch1 )
        theString[i] = ch2, counter++;
    return counter;
  }

