/* ClsDefs.h */

#ifndef __ClsDefs_h
#define __ClsDefs_h


/* Some useful #definitions */

// _CLASSDEF etc. definitions
#define _PTRDEF(name)      typedef       name*   P##name;
#define _REFDEF(name)      typedef       name&   R##name;
#define _REFPTRDEF(name)   typedef       name*& RP##name;
#define _PTRPTRDEF(name)   typedef       name** PP##name;
#define _PTRCONSTDEF(name) typedef const name*  PC##name;
#define _REFCONSTDEF(name) typedef const name&  RC##name;
#define _CLASSDEF(name) class name; \
  _PTRDEF(name)  \
  _REFDEF(name)   \
  _REFPTRDEF(name) \
  _PTRPTRDEF(name)  \
  _PTRCONSTDEF(name) \
  _REFCONSTDEF(name)

// Maximum & minimum
#define MAX(X,Y) ((X)<(Y)?(Y):(X))
#define MIN(X,Y) ((X)<(Y)?(X):(Y))

// Short self-reference inside class definition
#define ME (*this)

#define abstract

#define reg register
#define uns unsigned


/* Abbriviations for simple data types */

typedef unsigned int   uint;
typedef unsigned char  uchar;
typedef unsigned long  ulong;
typedef unsigned char  byte;
typedef unsigned short word;
typedef unsigned long  dword;


/* Some usefull constants and enum`s */

enum OK_ERROR { OK = 0, ERROR = -1 };

const int UNDEFINED = -1;


/* Error checking & reporting macroes */

// Report an error end return ERROR
#define RETURN_ERROR( error_message ) \
  { cerr << error_message << endl; return ERROR; }

// If the expressioin equals to ERROR reports error and returns ERROR
#define CHECK( expression, error_message ) \
  { if ( (expression)==ERROR ) RETURN_ERROR( error_message ) }


#endif // __ClsDefs_h

