/* CmdLnPrm.cpp */

#include "CmdLnPrm.h"

Settings readCommandLineParameters( const unsigned argc, const char* const argv[] )
  { //    -   (!!!)
    Settings settings;
    for ( unsigned i=1; i<argc; i++ )
      if ( argv[i][0] == '-' || argv[i][0] == '/' )
        switch ( argv[i][1] )
          {
          case 's' : settings.add( StringSetting( "SettingsFileName",
                       String(argv[i]).substring(2).trim() ) ); break;
          case 'L' : settings.add( StringSetting( "LogFileName",
                       String(argv[i]).substring(2).trim() ) ); break;
          case 'G' : settings.add( StringSetting( "GeneTreesFileName",
                       String(argv[i]).substring(2).trim() ) ); break;
          case 'R' : settings.add( StringSetting( "ResultFileName",
                       String(argv[i]).substring(2).trim() ) ); break;
          case 'S' : settings.add( StringSetting( "SpeciesTreeFileName",
                       String(argv[i]).substring(2).trim() ) ); break;
          case 'T' : settings.add( StringSetting( "GenesTableFileName",
                       String(argv[i]).substring(2).trim() ) ); break;
          case 't' : settings.add( IntegerSetting( "NumberOfRandomSpeciesTrees",
                       String(argv[i]).substring(2).trim() ) ); break;
          default  : cerr << "  "
                          << argv[i][0] << argv[i][1] << endl;
          }
      else
        cerr << "  " << argv[i] << "?" << endl;

    return settings;
  }
