/* ReadSets.h */

#include <fstream>

using namespace std;

#include "ClString.h"
#include "GlSttngs.h"

static OK_ERROR getNextLine( RString line, istream& file )
  {
    line = "";
    char c;
    do
      {
        if ( file.eof() )
          return ERROR;
        c=file.get();
        if ( file.eof() )
          if ( line == "" )
            return ERROR;
          else
            c = '\n';
        line += c;
      }
    while ( ! ( c == '\n' || file.eof() ) );
    return OK;
  }

inline static bool isUseable( RCString line )
  {
    return ( ! ( line.isBlank() ||
                 line.startsWith( ';' ) ||
                 line.startsWith( "//" ) ||
                 line.startsWith( "REM" ) ||
                 line.startsWith( "Rem" ) ||
                 line.startsWith( "rem" ) ) &&
             line.contains( '=' ) );
  }

void readGlobalSettings( istream& settingsFile )
  {
    String line;
    while ( getNextLine( line, settingsFile ) == OK )
      if ( isUseable( line ) )
        if ( globalSettings.set( line ) != OK )
          cout << "      :\n" << line;
  }
