/* TIQMax.h -   TreeInjectionQualityMaximizer */

#ifndef __TIQMax_h
#define __TIQMax_h

#include "TInject.h"  //   TreeInjector  TreeInjection
#include "TModify.h"  //    TreeModifier

/* "" #define    */
#define TIQMax TreeInjectionQualityMaximizer

_CLASSDEF(TIQMax)

/*    */
class TIQMax : public TreeInjector
  {

  public :

    TIQMax( RCClArray srcs_, RSpeciesTree trgt_ ) : TreeInjector(srcs_,trgt_) {}
    ~TIQMax() {}

    int maximize();  //   ӣ  ...

    int optimize_ByLevels_DownToUp()
      { return optimize_ByLevels_DownToUp( RSpeciesTree(target()) ); }
    int optimize_ByLevels_UpToDown()
      { return optimize_ByLevels_UpToDown( RSpeciesTree(target()) ); }
    int optimize_Recoursive_BestToWorst()
      { return optimize_Recoursive_BestToWorst( RSpeciesTree(target()) ); }
    int optimize_Recoursive_DownToUp()
      { return optimize_Recoursive_DownToUp( RSpeciesTree(target()) ); }
    int optimize_Recoursive_UpToDown()
      { return optimize_Recoursive_UpToDown( RSpeciesTree(target()) ); }

    int optimize_Nth_Level( uint n )
      { return optimize_Nth_Level( RSpeciesTree(target()), n ); }

  protected :

    int    optimize_ByLevels_DownToUp      ( RSpeciesTree modTree );
    int    optimize_ByLevels_UpToDown      ( RSpeciesTree modTree );
    int    optimize_Recoursive_BestToWorst ( RSpeciesTree modTree );
    int    optimize_Recoursive_DownToUp    ( RSpeciesTree modTree );
    int    optimize_Recoursive_UpToDown    ( RSpeciesTree modTree );

    int    optimize_Nth_Level( RSpeciesTree modTree, uint n );

    double optimize_Local( RSpeciesTree modTree );

  private :

    int bestVariantNumber( TreeModifier modifier );  //   

  };

#undef TIQMax

#endif  // __TIQMax_h

