/* TModify.h -   TreeModifier */

#ifndef __TModify_h
#define __TModify_h

#include "TreeMan.h"  //   TreeManipulator

_CLASSDEF(TreeModifier)

/*    (   ) */
class TreeModifier : private TreeManipulator
  {

  public :

    TreeModifier( RTree treeToModify );
    ~TreeModifier() {}

    void makeModification();         //    
    void makeModification( int i );  //     n
//    void restoreTree() { makeModification(0); }

    bool isUnabled          () const { return !nOfVars; }  //  
    uint numberOfVariants   () const { return  nOfVars; }  //  
    uint modificationNumber () const { return correctIndex(curVarN-startVarN); }

  private :

    uint correctIndex( int i ) const
      { return ( nOfVars>0 ? ( i%int(nOfVars) + (i<0)*nOfVars ) : 0 ); }

    uint  nOfVars;      //     
    uint  startVarN;    //    (  )
    uint  curVarN;      //    (0<=curVarN<nOfVars)
    PTree subtrees[5];  //      

    int   initializeSubtrees();  //     subtrees[]
    void  swapSubtrees( int i, int j );  //    

  };

#endif  // __TModify_h

