/* TreeBase.cpp */
/*
()
() **************************************************************************
() * -inline   TreeBase                                       *
() **************************************************************************
()
*/

#include "TreeBase.h"  //   TreeBase

/*
   --------------------------------------------------------------------------
   |    TreeBase                                        |
   --------------------------------------------------------------------------
*/
/*  */
TreeBase::~TreeBase()
  {
    if ( _children )  //  
      {
        for ( uint i=0; i<_nOfChildren; i++ )  //    
          delete _children[i];  //  i- 
        delete _children;  //     
      }
  }

/*
()       : flush();
()    :     ;
()   : ---;
()  : ---.
()
*/
void TreeBase::flush()
  {
    while ( hasChild() )  //   
      removeChild(0);  //    
  }

/*
()       : removeChild( int number )  ( );
()    :     ;
()   :    ;
()  :    / ERROR.
()
*/
int TreeBase::removeChild( const int n )
  {
    if ( n<0 || (uint)n>=_nOfChildren )  //    
      return ERROR;  // 

    delete _children[n];  //  

    return removeChildPtr(n);  //    
  }

/*
()       : removeChildPtr( int number )  (   );
()    :       ;
()   :    ;
()  :    / ERROR.
()
*/
int TreeBase::removeChildPtr( const int n )
  {
    if ( n<0 || (uint)n>=_nOfChildren )  //    
      return ERROR;  // 

    for ( uint i=n; i<_nOfChildren-1; i++ )  // 
      _children[i] = _children[i+1];

    atRemove();  //    ( ޣ )

    return numberOfChildren();  //    
  }

/*
()       : childNumber( TreeBase childToFind )  ( );
()    : ---;
()   :   ;
()  :      / UNDEFINED.
()
*/
int TreeBase::childNumber( RCTreeBase childToFind ) const
  {
    for ( uint n=0; n<_nOfChildren; n++ )  //    
      if ( _children[n] == &childToFind )  //  
        return n;  //  

    return UNDEFINED;  //  
  }

/*
   --------------------------------------------------------------------------
   |    TreeBase                                        |
   --------------------------------------------------------------------------
*/
/*
[]       : atAdd()  ( );
[]    :      ;
[]   : ---;
[]  :       / ERROR.
[]
*/
int TreeBase::atAdd()
  {
    if ( !( numberOfChildren() % _delta ) )  //     delta
      if ( hasChild() == false )           //  ݣ  
        _children = new TreeBase*[_delta]; //    delta 
      else  //   
        {                               //    
          TreeBase** new_pointer=new TreeBase*[ numberOfChildren() + _delta ];

          for ( uint i=0; i < numberOfChildren(); i ++ )  //   
            new_pointer[i] = _children[i];  //     

          delete _children;         //    
          _children = new_pointer;  //    
        }

    return _nOfChildren++;
  }

/*
[]       : atRemove()  ( );
[]    :      ;
[]   : ---;
[]  : OK / ERROR.
[]
*/
int TreeBase::atRemove()
  {
    --_nOfChildren;

    if ( numberOfChildren() % _delta )  //      delta
      return OK;                        //   

    if ( numberOfChildren() == 0 )  //     
      {
        delete _children;          //      
        _children = (TreeBase**)NULL;  //   
      }
    else                           //   
      {                            //    
        TreeBase** new_pointer=new TreeBase*[ numberOfChildren() ];

        for ( uint i=0; i < numberOfChildren(); i ++ ) //   
          new_pointer[i] = _children[i];  //   

        delete _children;         //   
        _children = new_pointer;  //   
      }

    return OK;
  }

