/* Variable.cpp */

#include "Variable.h"

TVariable::TVariable( const char* n, int t )
  {
    name = new char[ strlen( n ) + 1 ];
    strcpy( name, n );
    type = t;
    next = PTVariable( 0 );
  }

TVariableList::~TVariableList()
  {
    PTVariable cur, nxt;
    for ( cur = firstvariable; cur; delete cur, cur = nxt )
      nxt = cur->next;
  }

PTVariable TVariableList::add( PTVariable Pvar )
  {
    PTVariable tmp = find( Pvar->name );
    if ( tmp )
      remove( tmp->name );
    Pvar->next = firstvariable;
    firstvariable = Pvar;
    return Pvar;
  }

int TVariableList::remove( const char* n )
  {
    PTVariable prev, cur;
    for ( cur = prev = firstvariable; cur; prev = cur, cur = cur->next )
      if ( !strcmp( cur->name, n ) )
	{
	  prev->next = cur->next;
	  delete cur;
	  return 0;
	}
    return 1;
  }

PTVariable TVariableList::find( const char* n )
  {
    PTVariable cur;
    for ( cur = firstvariable; cur; cur = cur->next )
      if ( !strcmp( cur->name, n ) )
	return cur;
    return cur;
  }

void TVariableList::printon( ostream& os )
  {
    for ( PTVariable cur = firstvariable; cur; cur = cur->next )
      cur->printon( os );
  }
